<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<!-- 2021-12-03 Fri 15:43 -->
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<title>Interactive Dotfile Management With Dotbare</title>
<meta name="author" content="dt" />
<meta name="description" content="Guest Articles - Interactive Dotfile Management With Dotbare
Header" />
<meta name="generator" content="Org Mode" />
<style>
  #content { max-width: 60em; margin: auto; }
  .title  { text-align: center;
             margin-bottom: .2em; }
  .subtitle { text-align: center;
              font-size: medium;
              font-weight: bold;
              margin-top:0; }
  .todo   { font-family: monospace; color: red; }
  .done   { font-family: monospace; color: green; }
  .priority { font-family: monospace; color: orange; }
  .tag    { background-color: #eee; font-family: monospace;
            padding: 2px; font-size: 80%; font-weight: normal; }
  .timestamp { color: #bebebe; }
  .timestamp-kwd { color: #5f9ea0; }
  .org-right  { margin-left: auto; margin-right: 0px;  text-align: right; }
  .org-left   { margin-left: 0px;  margin-right: auto; text-align: left; }
  .org-center { margin-left: auto; margin-right: auto; text-align: center; }
  .underline { text-decoration: underline; }
  #postamble p, #preamble p { font-size: 90%; margin: .2em; }
  p.verse { margin-left: 3%; }
  pre {
    border: 1px solid #e6e6e6;
    border-radius: 3px;
    background-color: #f2f2f2;
    padding: 8pt;
    font-family: monospace;
    overflow: auto;
    margin: 1.2em;
  }
  pre.src {
    position: relative;
    overflow: auto;
  }
  pre.src:before {
    display: none;
    position: absolute;
    top: -8px;
    right: 12px;
    padding: 3px;
    color: #555;
    background-color: #f2f2f299;
  }
  pre.src:hover:before { display: inline; margin-top: 14px;}
  /* Languages per Org manual */
  pre.src-asymptote:before { content: 'Asymptote'; }
  pre.src-awk:before { content: 'Awk'; }
  pre.src-authinfo::before { content: 'Authinfo'; }
  pre.src-C:before { content: 'C'; }
  /* pre.src-C++ doesn't work in CSS */
  pre.src-clojure:before { content: 'Clojure'; }
  pre.src-css:before { content: 'CSS'; }
  pre.src-D:before { content: 'D'; }
  pre.src-ditaa:before { content: 'ditaa'; }
  pre.src-dot:before { content: 'Graphviz'; }
  pre.src-calc:before { content: 'Emacs Calc'; }
  pre.src-emacs-lisp:before { content: 'Emacs Lisp'; }
  pre.src-fortran:before { content: 'Fortran'; }
  pre.src-gnuplot:before { content: 'gnuplot'; }
  pre.src-haskell:before { content: 'Haskell'; }
  pre.src-hledger:before { content: 'hledger'; }
  pre.src-java:before { content: 'Java'; }
  pre.src-js:before { content: 'Javascript'; }
  pre.src-latex:before { content: 'LaTeX'; }
  pre.src-ledger:before { content: 'Ledger'; }
  pre.src-lisp:before { content: 'Lisp'; }
  pre.src-lilypond:before { content: 'Lilypond'; }
  pre.src-lua:before { content: 'Lua'; }
  pre.src-matlab:before { content: 'MATLAB'; }
  pre.src-mscgen:before { content: 'Mscgen'; }
  pre.src-ocaml:before { content: 'Objective Caml'; }
  pre.src-octave:before { content: 'Octave'; }
  pre.src-org:before { content: 'Org mode'; }
  pre.src-oz:before { content: 'OZ'; }
  pre.src-plantuml:before { content: 'Plantuml'; }
  pre.src-processing:before { content: 'Processing.js'; }
  pre.src-python:before { content: 'Python'; }
  pre.src-R:before { content: 'R'; }
  pre.src-ruby:before { content: 'Ruby'; }
  pre.src-sass:before { content: 'Sass'; }
  pre.src-scheme:before { content: 'Scheme'; }
  pre.src-screen:before { content: 'Gnu Screen'; }
  pre.src-sed:before { content: 'Sed'; }
  pre.src-sh:before { content: 'shell'; }
  pre.src-sql:before { content: 'SQL'; }
  pre.src-sqlite:before { content: 'SQLite'; }
  /* additional languages in org.el's org-babel-load-languages alist */
  pre.src-forth:before { content: 'Forth'; }
  pre.src-io:before { content: 'IO'; }
  pre.src-J:before { content: 'J'; }
  pre.src-makefile:before { content: 'Makefile'; }
  pre.src-maxima:before { content: 'Maxima'; }
  pre.src-perl:before { content: 'Perl'; }
  pre.src-picolisp:before { content: 'Pico Lisp'; }
  pre.src-scala:before { content: 'Scala'; }
  pre.src-shell:before { content: 'Shell Script'; }
  pre.src-ebnf2ps:before { content: 'ebfn2ps'; }
  /* additional language identifiers per "defun org-babel-execute"
       in ob-*.el */
  pre.src-cpp:before  { content: 'C++'; }
  pre.src-abc:before  { content: 'ABC'; }
  pre.src-coq:before  { content: 'Coq'; }
  pre.src-groovy:before  { content: 'Groovy'; }
  /* additional language identifiers from org-babel-shell-names in
     ob-shell.el: ob-shell is the only babel language using a lambda to put
     the execution function name together. */
  pre.src-bash:before  { content: 'bash'; }
  pre.src-csh:before  { content: 'csh'; }
  pre.src-ash:before  { content: 'ash'; }
  pre.src-dash:before  { content: 'dash'; }
  pre.src-ksh:before  { content: 'ksh'; }
  pre.src-mksh:before  { content: 'mksh'; }
  pre.src-posh:before  { content: 'posh'; }
  /* Additional Emacs modes also supported by the LaTeX listings package */
  pre.src-ada:before { content: 'Ada'; }
  pre.src-asm:before { content: 'Assembler'; }
  pre.src-caml:before { content: 'Caml'; }
  pre.src-delphi:before { content: 'Delphi'; }
  pre.src-html:before { content: 'HTML'; }
  pre.src-idl:before { content: 'IDL'; }
  pre.src-mercury:before { content: 'Mercury'; }
  pre.src-metapost:before { content: 'MetaPost'; }
  pre.src-modula-2:before { content: 'Modula-2'; }
  pre.src-pascal:before { content: 'Pascal'; }
  pre.src-ps:before { content: 'PostScript'; }
  pre.src-prolog:before { content: 'Prolog'; }
  pre.src-simula:before { content: 'Simula'; }
  pre.src-tcl:before { content: 'tcl'; }
  pre.src-tex:before { content: 'TeX'; }
  pre.src-plain-tex:before { content: 'Plain TeX'; }
  pre.src-verilog:before { content: 'Verilog'; }
  pre.src-vhdl:before { content: 'VHDL'; }
  pre.src-xml:before { content: 'XML'; }
  pre.src-nxml:before { content: 'XML'; }
  /* add a generic configuration mode; LaTeX export needs an additional
     (add-to-list 'org-latex-listings-langs '(conf " ")) in .emacs */
  pre.src-conf:before { content: 'Configuration File'; }

  table { border-collapse:collapse; }
  caption.t-above { caption-side: top; }
  caption.t-bottom { caption-side: bottom; }
  td, th { vertical-align:top;  }
  th.org-right  { text-align: center;  }
  th.org-left   { text-align: center;   }
  th.org-center { text-align: center; }
  td.org-right  { text-align: right;  }
  td.org-left   { text-align: left;   }
  td.org-center { text-align: center; }
  dt { font-weight: bold; }
  .footpara { display: inline; }
  .footdef  { margin-bottom: 1em; }
  .figure { padding: 1em; }
  .figure p { text-align: center; }
  .equation-container {
    display: table;
    text-align: center;
    width: 100%;
  }
  .equation {
    vertical-align: middle;
  }
  .equation-label {
    display: table-cell;
    text-align: right;
    vertical-align: middle;
  }
  .inlinetask {
    padding: 10px;
    border: 2px solid gray;
    margin: 10px;
    background: #ffffcc;
  }
  #org-div-home-and-up
   { text-align: right; font-size: 70%; white-space: nowrap; }
  textarea { overflow-x: auto; }
  .linenr { font-size: smaller }
  .code-highlighted { background-color: #ffff00; }
  .org-info-js_info-navigation { border-style: none; }
  #org-info-js_console-label
    { font-size: 10px; font-weight: bold; white-space: nowrap; }
  .org-info-js_search-highlight
    { background-color: #ffff00; color: #000000; font-weight: bold; }
  .org-svg { width: 90%; }
</style>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
</head>
<body>
<div id="content" class="content">
<h1 class="title">Interactive Dotfile Management With Dotbare</h1>
<div id="table-of-contents" role="doc-toc">
<h2>Table of Contents</h2>
<div id="text-table-of-contents" role="doc-toc">
<ul>
<li><a href="#orga772a04">Interactive Dotfile Management With Dotbare</a></li>
<li><a href="#orgbb76b0d">How it works</a></li>
<li><a href="#org381878f">Set up</a></li>
<li><a href="#org1cc903d">Usage</a></li>
<li><a href="#orgb01be24">Migration made easy</a></li>
<li><a href="#org01cc4ee">Integration with Symlink setup/GNU stow setup</a></li>
<li><a href="#orgd37b6f0">Conclusion</a></li>
<li><a href="#org23b3a32">Links</a></li>
</ul>
</div>
</div>
<table border="2" cellspacing="0" cellpadding="6" rules="groups" frame="hsides">


<colgroup>
<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />
</colgroup>
<tbody>
<tr>
<td class="org-left"><a href="../index.html">Home</a></td>
<td class="org-left"><a href="../dtos/index.html">DTOS</a></td>
<td class="org-left"><a href="../kb/index.html">Knowledge Base</a></td>
<td class="org-left"><a href="../community/index.html">Community</a></td>
<td class="org-left"><a href="../contribute/index.html">Contribute</a></td>
<td class="org-left"><a href="../support/index.html">Support DT&rsquo;s Work</a></td>
</tr>
</tbody>
</table>

<div id="outline-container-orga772a04" class="outline-2">
<h2 id="orga772a04">Interactive Dotfile Management With Dotbare</h2>
<div class="outline-text-2" id="text-orga772a04">
<p>
<i>By Kevin Zhuang at May 25, 2020</i>
</p>

<p>
When it comes to dotfile management, I find that the method of using a git bare repository is the easiest and most straight forward method to use. However, it comes with two limitations that bothered me quite a lot. It doesn&rsquo;t have any command line completion by default and it has the annoying checkout issue during migration to new systems.
</p>

<p>
dotbare is a command line utility that by default wraps around git bare repository and aims to provide an interactive experience with the help of fzf. Don&rsquo;t worry about migration if you are using a Symlink method/GNU stow, dotbare could easily be integrated with them. In this blog, I will go through how to easily set up and use dotbare.
</p>
</div>
</div>

<div id="outline-container-orgbb76b0d" class="outline-2">
<h2 id="orgbb76b0d">How it works</h2>
<div class="outline-text-2" id="text-orgbb76b0d">
<p>
In a nutshell, dotbare is a wrapper around a .git repository and provides a series of scripts that process git information and populate into fzf. DT&rsquo;s video really helped me understand how the underlying git bare repository works.
</p>
</div>
</div>

<div id="outline-container-org381878f" class="outline-2">
<h2 id="org381878f">Set up</h2>
<div class="outline-text-2" id="text-org381878f">
<p>
For first time usage of git bare method, run the following command and dotbare would setup everything for you.
</p>

<pre class="example" id="org5b639f3">
# By default, dotbare will initialise a bare repository in $HOME/.cfg
# To change this location, put export DOTBARE_DIR=&lt;Your location&gt; in shellrc (e.g. .zshrc, .bashrc)
dotbare finit

# after initialisation, you can start staging/committing files and push it to remote repo.
dotbare fadd  # interactive stage files
dotbare commit -m &lt;message&gt;
dotbare push
</pre>

<p>
For existing git bare user, simply check your existing git bare alias for reference and set up the following ENV variable in your shellrc (e.g. .zshrc, .bashrc) to inform dotbare. After setting up the ENV variable you could remove the alias or alias the original config to dotbare so that you keep your muscle memory.
</p>

<pre class="example" id="org457e2e1">
# Below is an example alias, check yours for reference
alias config=/usr/bin/git --git-dir=$HOME/.cfg --work-tree=$HOME
export DOTBARE_DIR="$HOME/.cfg"
export DOTBARE_TREE="$HOME"
</pre>
</div>
</div>

<div id="outline-container-org1cc903d" class="outline-2">
<h2 id="org1cc903d">Usage</h2>
<div class="outline-text-2" id="text-org1cc903d">
<p>
Treat dotbare as normal git commands(e.g. dotbare commit dotbare reset HEAD~ etc). dotbare comes with a set of interactive commands with a prefix f, it supports most of the everyday git usage interactively.
</p>

<pre class="example" id="org3134481">
dotbare fadd        # interactive stage files
dotbare fedit       # interactive select and edit dotfiles
dotbare flog        # interactive log viewer and editor
dotbare fcheckout   # interactive reset file changes to HEAD or checkout branch/commits.
dotbare fbackup     # backup dotfiles
dotbare freset      # interactive unstage files
dotbare finit       # initialise dotbare or migration to new system
dotbare fstash      # interactive stash management
dotbare funtrack    # interactive select files and untrack from your index
dotbare fstat       # toggle stage/unstage of files
</pre>
</div>
</div>

<div id="outline-container-orgb01be24" class="outline-2">
<h2 id="orgb01be24">Migration made easy</h2>
<div class="outline-text-2" id="text-orgb01be24">
<p>
When migrating to new systems, traditional git bare method has the annoying checkout issue that you will need to solve when checking out the git bare repository. dotbare made this migrating super easy.
</p>

<pre class="example" id="org5fbc693">
dotbare finit -u [URL]
</pre>

<p>
Simply run the command with your remote url and dotbare will automatically handle the checkout, backup and set everything up for you.
</p>
</div>
</div>

<div id="outline-container-org01cc4ee" class="outline-2">
<h2 id="org01cc4ee">Integration with Symlink setup/GNU stow setup</h2>
<div class="outline-text-2" id="text-org01cc4ee">
<p>
If you are currently using this type of method to mange dotfiles, but are interested in dotbare, you don&rsquo;t need to migrate anything, you simply need to set two environment variables to let dotbare aware where to query the git information.
</p>

<pre class="example" id="orgd51a784">
# e.g. I have all my dotfiles stored in folder $HOME/.myworld and symlinks all of them to appropriate location.
# export DOTBARE_DIR="$HOME/.myworld/.git"
# export DOTBARE_TREE="$HOME/.myworld"
export DOTBARE_DIR=&lt;Path to your .git directory&gt;
export DOTBARE_TREE=&lt;Path to directory which contains all your dotfiles&gt;
</pre>
</div>
</div>

<div id="outline-container-orgd37b6f0" class="outline-2">
<h2 id="orgd37b6f0">Conclusion</h2>
<div class="outline-text-2" id="text-orgd37b6f0">
<p>
dotbare is definitely not for everyone, it requires bash on the system as well as an installation of fzf. This is only a quick start on dotbare, you could find out more information about usage, customization, demo and various installation method over on GitHub.
</p>
</div>
</div>

<div id="outline-container-org23b3a32" class="outline-2">
<h2 id="org23b3a32">Links</h2>
<div class="outline-text-2" id="text-org23b3a32">
<ul class="org-ul">
<li><a href="https://github.com/kazhala/dotbare">Dotbare on GitHub</a></li>
</ul>
</div>
</div>
</div>
<div id="postamble" class="status">
<p class="author">Author: dt</p>
<p class="date">Created: 2021-12-03 Fri 15:43</p>
</div>
</body>
</html>
